/**
 * TCS Dependency Map Renderer
 *
 * Copyright (c) 2005 TopCoder, Inc. All rights Reserved.
 */
package com.topcoder.rules.dependencymap.view.AccuracyTests;

import java.awt.Insets;

import junit.framework.TestCase;

import com.topcoder.rules.dependencymap.view.Dependency;
import com.topcoder.rules.dependencymap.view.DependencyRenderer;
import com.topcoder.rules.dependencymap.view.DiagramRenderer;
import com.topcoder.rules.dependencymap.view.ShapeFactory;

/**
 * Provides some initialization for layout tests.
 *
 * @author cucu
 */
public abstract class BaseLayoutTests extends TestCase{
    protected MockGraphics graphics = new MockGraphics();
    protected DependencyRenderer renderer = null;
    protected DiagramRenderer diagramRenderer = null;
    protected GraphicsHelper gh = null;
    protected Dependency a = null;
    protected Dependency b = null;
    protected Dependency c = null;
    protected Dependency d = null;
    protected Dependency e = null;
    protected Dependency f = null;
    protected Dependency g = null;

    protected abstract DiagramRenderer createDiagramRenderer();
    protected abstract void compare(String test, GraphicsHelper gh, DiagramRenderer dr);

    /**
     * Set up for each test.
     */
    public void setUp() {
        renderer = new DependencyRenderer();
        diagramRenderer = createDiagramRenderer();
        renderer.addDiagramRenderer(diagramRenderer);

        a = new Dependency("A");
        b = new Dependency("B");
        c = new Dependency("C");
        d = new Dependency("D");
        e = new Dependency("E");
        f = new Dependency("F");
        g = new Dependency("G");

        gh = new GraphicsHelper(new ShapeFactory(), graphics, 10, 10, new Insets(10, 10, 10, 10));
    }

}
