/**
 * TCS Dependency Map Renderer
 *
 * Copyright (c) 2005 TopCoder, Inc. All rights Reserved.
 */
package com.topcoder.rules.dependencymap.view.AccuracyTests.Enh2;

import java.awt.image.BufferedImage;

import com.topcoder.rules.dependencymap.view.BufferedImageRenderer;
import com.topcoder.rules.dependencymap.view.DiagramRenderer;
import com.topcoder.rules.dependencymap.view.AccuracyTests.GraphicsHelper;
import com.topcoder.rules.dependencymap.view.AccuracyTests.LayoutAbstractTests;
import com.topcoder.rules.dependencymap.view.AccuracyTests.MockGraphics;
import com.topcoder.rules.dependencymap.view.AccuracyTests.TestsHelper;

/**
 * Test for enhancement 2: rendering pictures as BMP.
 *
 * @author cucu
 *
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Enh2Tests extends LayoutAbstractTests {

    private BufferedImage image = null;
    private BufferedImageRenderer bir = null;

    /**
     * Generates an instance of DiagramRenderer that will be used for the tests.
     */
    protected DiagramRenderer createDiagramRenderer() {
        bir = new BufferedImageRenderer(500,500,BufferedImage.TYPE_INT_RGB);

        return bir;
    }

    /**
     * Initialization for the enhancement 2 tests.
     */
    public Enh2Tests() {
        image = new BufferedImage(500,500,BufferedImage.TYPE_INT_RGB);
        graphics = new MockGraphics(image);
    }

    /**
     * Save the expected bitmap and the resulting bitmap. Please compare them visually.
     */
    protected void compare(String test, GraphicsHelper gh, DiagramRenderer dr) {
        TestsHelper.saveBMP("test_files\\enh2\\" + test + "_result.bmp",  bir.getBufferedImage());
        gh.getGraphics().save("test_files\\enh2\\" + test + "_expected");
    }

}
